package ru.dbotthepony.kstarbound.defs.item

import ru.dbotthepony.kstarbound.Starbound
import ru.dbotthepony.kstarbound.io.json.FactoryAdapter
import ru.dbotthepony.kstarbound.io.json.ifString

interface IArmorItemDefinition : ILeveledItemDefinition, IScriptableItemDefinition {
	/**
	 * @see ArmorPieceType
	 */
	val armorType: ArmorPieceType

	/**
	 * Варианты покраски (???)
	 */
	val colorOptions: List<Map<String, String>>

	/**
	 * Визуальные кадры анимации, когда надето на гуманоида мужского пола
	 */
	val maleFrames: IArmorFrames

	/**
	 * Визуальные кадры анимации, когда надето на гуманоида женского пола
	 */
	val femaleFrames: IArmorFrames

	interface IArmorFrames {
		val body: String
		val backSleeve: String?
		val frontSleeve: String?
	}

	data class ArmorFrames(
		override val body: String,
		override val backSleeve: String?,
		override val frontSleeve: String?,
	) : IArmorFrames {
		companion object {
			val ADAPTER = FactoryAdapter.Builder(
				ArmorFrames::class,
				ArmorFrames::body,
				ArmorFrames::backSleeve,
				ArmorFrames::frontSleeve,
			)
				.build()
				.ifString { ArmorFrames(Starbound.assetFolder(it), null, null) }
		}
	}
}
