package ru.dbotthepony.kstarbound.defs.item

interface ICurrencyItemDefinition : IItemDefinition {
	/**
	 * Звуки при поднятии "малого" количества предметов. Не имеет никакого смысла без [smallStackLimit]
	 */
	val pickupSoundsSmall: List<String>

	/**
	 * Звуки при поднятии "среднего" количества предметов. Не имеет никакого смысла без [mediumStackLimit]
	 */
	val pickupSoundsMedium: List<String>

	/**
	 * Звуки при поднятии "большого" количества предметов. Не имеет никакого смысла без [smallStackLimit] и без [mediumStackLimit]
	 */
	val pickupSoundsLarge: List<String>

	/**
	 * Количество предметов ниже или равному данному значению проиграет звук [pickupSoundsSmall]
	 */
	val smallStackLimit: Long

	/**
	 * Количество предметов ниже или равному данному значению (но не меньше [smallStackLimit]) проиграет звук [pickupSoundsMedium]
	 */
	val mediumStackLimit: Long

	/**
	 * ID валюты
	 */
	val currency: String

	/**
	 * Ценность одного предмета в [currency]
	 */
	val value: Long
}
