package ru.dbotthepony.kstarbound.defs.item

import ru.dbotthepony.kstarbound.defs.IThingWithDescription
import ru.dbotthepony.kstarbound.defs.MaterialReference
import ru.dbotthepony.kstarbound.defs.ThingDescription

data class MaterialItemDefinition(
	override val itemName: String,
	override val price: Long,
	override val rarity: ItemRarity,
	override val category: String?,
	override val inventoryIcon: List<IItemDefinition.IInventoryIcon>?,
	override val itemTags: List<String>,
	override val learnBlueprintsOnPickup: List<String>,
	override val maxStack: Long,
	override val eventCategory: String?,
	override val consumeOnPickup: Boolean,
	override val pickupQuestTemplates: List<String>,
	override val tooltipKind: ItemTooltipKind,
	override val twoHanded: Boolean,
	override val radioMessagesOnPickup: List<String>,
	override val fuelAmount: Long?,

	override val material: MaterialReference,

	val descriptionData: ThingDescription,

	val json: Map<String, Any>
) : IMaterialItem, IThingWithDescription by descriptionData
